theory euclidsalg
imports Main GCD
begin

  value "gcd (42::nat) 18"
  thm gcd_nat.simps
  
  lemma gcd_dvd_both: "(gcd m (n::nat) dvd m) & (gcd m n dvd n)"
  thm gcd_nat.induct
  apply(induct_tac m n rule:gcd_nat.induct)
  apply(case_tac "y=0")
  apply(simp)
  thm dvd_mod_imp_dvd
  apply(blast dest: dvd_mod_imp_dvd)
  done

  lemmas gcd_dvd1 [iff] = gcd_dvd_both [THEN conjunct1]
  lemmas gcd_dvd2 [iff] = gcd_dvd_both [THEN conjunct2]

  lemma gcd_greatest [rule_format]:
    "(k::nat) dvd m \<longrightarrow> k dvd n \<longrightarrow> k dvd gcd m n"  
  apply(induct_tac m n rule:gcd_nat.induct)
  apply(case_tac "y=0")
  thm dvd_mod
  apply(simp_all add: dvd_mod)
  done

  theorem gcd_greatest_iff [iff]:
    "((k::nat) dvd gcd m n) = (k dvd m & k dvd n)"
  by (blast intro!: gcd_greatest intro: dvd_trans)


end