theory Proba
imports Main
begin
  
  lemma "[| ~ m < n; m < n + (1::nat) |] ==> m = n"
  apply(auto)
  done

  lemma "m ~= (n::nat) ==> m < n | n < m"
  apply(auto)
  done

  lemma "min i (max j (k*k)) = max (min (k*k) i) (min i (j::nat))"
  apply(arith)
  done

  lemma "n*n = n+(1::nat) ==>  n=0"
  apply(induct_tac n)
  apply(auto)
  oops

  lemma "[| xs @ zs = ys @ xs; [] @ xs = [] @ [] |] ==> ys = zs"
  apply simp
  done

  lemma hd_Cons_tl2[simp]: "xs ~= [] ==> (hd xs) # (tl xs) = xs"
  apply(case_tac xs,simp,simp)
  done

  lemma conj_rule: "[| P; Q |] ==> P & (Q & P)"
  apply (rule conjI)
  apply assumption
  apply (rule conjI)
  apply assumption
  apply assumption
  done

  lemma disj_swap: "P | Q ==> Q | P"
  apply (erule disjE)
  apply (rule disjI2)
  apply assumption
  apply (rule disjI1)
  apply assumption
  done

  lemma conj_swap: "P & Q ==> Q & P"
  apply (rule conjI)
  apply (drule conjunct2)
  apply assumption
  apply (drule conjunct1)
  apply assumption
  done

  lemma imp_uncurry: "P \<longrightarrow>  (Q \<longrightarrow> R) \<Longrightarrow> P & Q \<longrightarrow> R"
  apply (rule impI)
  apply (erule conjE)
  apply (drule mp)
  apply assumption
  apply (drule mp)
  apply assumption
  apply assumption
  done

  lemma "[| ~(P \<longrightarrow> Q); ~(R \<longrightarrow> Q) |] ==> R"  
  apply (erule_tac Q = "R \<longrightarrow> Q" in contrapos_np)
  apply (intro impI)
  by (erule notE)

  lemma "[| x = f x; odd(f x) |] ==> odd x"
  apply (erule ssubst)  
  apply (assumption)
  done

  lemma "!x. P x  --> P x"
  apply (rule allI)
  by (rule impI)

  lemma confectionery: "\<lbrakk> IsCake r;           
           ALL x. EX y. (IsCake(x) \<longrightarrow> (IsCust(y) & Like(y,x)));
           ALL x. (IsCust(x) & HasDiabetes(x) \<longrightarrow> ~Like(x,r)) \<rbrakk> 
             \<Longrightarrow> EX x. (IsCust(x) & ~HasDiabetes(x))"
  by(blast)
  
end