theory ToyTree
imports Main
begin
  datatype 'a tree = Tip
                   | Node "'a tree" 'a "'a tree"

  (* mirror *)
  primrec mirror :: "'a tree => 'a tree"
  where
  "mirror(Tip) = Tip" |
  "mirror(Node l x r) = Node (mirror r) x (mirror l)"

  value "mirror (Node Tip 0 (Node Tip 1 Tip))"

  lemma mirror_mirror [simp]: "mirror(mirror t) = t"
  apply(induct_tac t)
  apply(simp)
  apply(auto)
  done

  thm mirror_mirror
  thm mirror.simps

  primrec flatten :: " 'a tree \<Rightarrow> 'a list"
  where
    "flatten Tip = []" |
    "flatten (Node l x r) = (flatten l) @ (x # (flatten r))"

  lemma "flatten (mirror t) = rev(flatten t)"
  apply(induct_tac t)
  by (auto)


  primrec flatten2 :: " 'a tree \<Rightarrow> 'a list \<Rightarrow> 'a list "
  where 
    "flatten2 Tip akk = akk" |
    "flatten2 (Node l x r) akk = (flatten2 l (x # (flatten2 r akk)))"

  value "flatten2 (Node (Node Tip 3 Tip) 0 (Node (Node Tip 5 Tip) 1 Tip)) []"

  (* Prove that "flatten2 t [] = flatten t" *)

  lemma flatten_eq: "!akk. flatten2 t akk = (flatten t) @ akk"
  apply(induct_tac t)
  apply(auto)
  done

  thm allI

  lemmas flatten_eq0 = flatten_eq [THEN spec, of _ "[]", simplified] 
  
  
end